# cnos_save – Save the running configuration as the startup configuration on devices running Lenovo CNOS

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- This module allows you to copy the running configuration of a switch over its startup configuration. It is recommended to use this module shortly after any major configuration changes so they persist after a switch restart. This module uses SSH to manage network device configuration. The results of the operation will be placed in a directory named ‘results’ that must be created by the user in their local directory to where the playbook is run.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

deviceType
string / required

Choices:
- g8272_cnos
- g8296_cnos
- g8332_cnos
- NE0152T
- NE1072T
- NE1032
- NE1032T
- NE10032
- NE2572

This specifies the type of device where the method is executed. The choices NE1072T,NE1032,NE1032T,NE10032,NE2572 are added since Ansible 2.4. The choice NE0152T is added since 2.8

enablePassword string |  | Configures the password used to enter Global Configuration command mode on the switch. If the switch does not request this password, the parameter is ignored.While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.
host string / required |  | This is the variable used to search the hosts file at /etc/ansible/hosts and identify the IP address of the device on which the template is going to be applied. Usually the Ansible keyword {{ inventory_hostname }} is specified in the playbook as an abstraction of the group of network elements that need to be configured.
outputfile string / required |  | This specifies the file path where the output of each command execution is saved. Each command that is specified in the merged template file and each response from the device are saved here. Usually the location is the results folder, but you can choose another location based on your write permission.
password string / required |  | Configures the password used to authenticate the connection to the remote device. The value of the password parameter is used to authenticate the SSH session. While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.
username string / required |  | Configures the username used to authenticate the connection to the remote device. The value of the username parameter is used to authenticate the SSH session. While generally the value should come from the inventory file, you can also specify it as a variable. This parameter is optional. If it is not specified, no default value will be used.

## Notes

Note

- For more information on using Ansible to manage Lenovo Network devices see https://www.ansible.com/ansible-lenovo.

## Examples

    Tasks : The following are examples of using the module cnos_save. These are
     written in the main.yml file of the tasks directory.
    ---
    - name: Test Save
      cnos_save:
          deviceType: "{{ hostvars[inventory_hostname]['deviceType'] }}"
          outputfile: "./results/test_save_{{ inventory_hostname }}_output.txt"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
msg string | always | Success or failure message Sample: Switch Running Config is Saved to Startup Config

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Anil Kumar Muraleedharan (@amuraleedhar)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.